Debian Bug report logs - #493925
binary firmware in drivers/char/drm/mga_ucode.h

version graph

Package: linux-2.6; Maintainer for linux-2.6 is Debian Kernel Team <debian-kernel@lists.debian.org>;

Reported by: Robert Millan <rmh@aybabtu.com>

Date: Tue, 5 Aug 2008 22:45:02 UTC

Severity: wishlist

Tags: help

Found in versions 2.6.26-1, 2.6.18-1

Fixed in version 2.6.29-1

Done: Ben Hutchings <ben@decadent.org.uk>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Robert Millan <rmh@aybabtu.com>:
New Bug report received and forwarded. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@aybabtu.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: binary firmware in drivers/char/drm/mga_ucode.h
Date: Wed, 06 Aug 2008 00:40:53 +0200
Package: linux-2.6
Version: 2.6.26-1
Severity: serious

Hi,

Now that it seems clear 2.6.26 will be the version used for the release, I'd
like to bring back attention on pruning it from code under DFSG violation,
GPL-incompatible, or unlicensed blobs.

Based on maks mail in:

  http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=242866#308

  "file a separate report on each issue that you find and we'll analyse your
  findings"

I'll file a separate report on each issue I find.  Will try to make them as
detailed as possible.

--------------------------------------------------------------------------------

drivers/char/drm/mga_ucode.h (licensed under BSD-style terms) is entirely
composed of binary code, such as:

static unsigned char warp_g200_tgz[] = {

        0x00, 0x80, 0x00, 0xE8,
        0x00, 0x80, 0x00, 0xE8,
	[...]

drivers/char/drm/mga_warp.c relies on those chunks of non-free code.

Since the licensing terms allow redistribution, shipping it is not illegal but
is a DFSG violation.

-- System Information:
Debian Release: 4.0
  APT prefers stable
  APT policy: (500, 'stable')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.18-6-amd64
Locale: LANG=ca_AD.UTF-8, LC_CTYPE=ca_AD.UTF-8 (charmap=UTF-8)




Bug marked as found in version 2.6.18-1. Request was from Bastian Blank <waldi@debian.org> to control@bugs.debian.org. (Tue, 05 Aug 2008 23:54:03 GMT) Full text and rfc822 format available.

Tags added: help Request was from Bastian Blank <waldi@debian.org> to control@bugs.debian.org. (Wed, 06 Aug 2008 16:36:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to maximilian attems <max@stro.at>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #14 received at 493925@bugs.debian.org (full text, mbox):

From: maximilian attems <max@stro.at>
To: Robert Millan <rmh@aybabtu.com>, 493925@bugs.debian.org
Subject: Re: Bug#493925: binary firmware in drivers/char/drm/mga_ucode.h
Date: Thu, 4 Sep 2008 14:14:28 +0200
severity 493925 wishlist
stop

On Wed, 06 Aug 2008, Robert Millan wrote:

> Now that it seems clear 2.6.26 will be the version used for the release, I'd
> like to bring back attention on pruning it from code under DFSG violation,
> GPL-incompatible, or unlicensed blobs.

as always stupid Debian wolf crying - disconnected from upstream work.
checkout 2.6.27-rcX they already ported several drivers to
request_firmware and if you *had* checked out linux-next you would
see that even more is in the pipe. 2.6.26 is not the right cut off.
and if you really cared why did nobody chime in there?

also you seem to not have checkout documented past efforts or asked
any upstream vendor to relicense, both requiring *real* work.
http://wiki.debian.org/KernelFirmwareLicensing
 
> Based on maks mail in:
> 
>   http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=242866#308
> 
>   "file a separate report on each issue that you find and we'll analyse your
>   findings"
> 
> I'll file a separate report on each issue I find.  Will try to make them as
> detailed as possible.

ack, thanks.
 
> --------------------------------------------------------------------------------
> 
> drivers/char/drm/mga_ucode.h (licensed under BSD-style terms) is entirely
> composed of binary code, such as:

*BSD* license right.
 
> static unsigned char warp_g200_tgz[] = {
> 
>         0x00, 0x80, 0x00, 0xE8,
>         0x00, 0x80, 0x00, 0xE8,
> 	[...]
> 
> drivers/char/drm/mga_warp.c relies on those chunks of non-free code.
> 
> Since the licensing terms allow redistribution, shipping it is not illegal but
> is a DFSG violation.

why?

-- 
maks




Severity set to `wishlist' from `serious' Request was from maximilian attems <max@stro.at> to control@bugs.debian.org. (Thu, 04 Sep 2008 12:15:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Message #19 received at 493925@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@aybabtu.com>
To: maximilian attems <max@stro.at>
Cc: 493925@bugs.debian.org
Subject: Re: Bug#493925: binary firmware in drivers/char/drm/mga_ucode.h
Date: Thu, 4 Sep 2008 14:44:45 +0200
On Thu, Sep 04, 2008 at 02:14:28PM +0200, maximilian attems wrote:
> severity 493925 wishlist
> stop

I don't want to play BTS ping-pong, but this severity change is not right.
Would you please revert it?

> as always stupid Debian wolf crying - disconnected from upstream work.
> checkout 2.6.27-rcX they already ported several drivers to
> request_firmware and if you *had* checked out linux-next you would
> see that even more is in the pipe. 2.6.26 is not the right cut off.

Isn't .26 the version that will be used for lenny?

> > Since the licensing terms allow redistribution, shipping it is not illegal but
> > is a DFSG violation.
> 
> why?

DFSG #2.

-- 
Robert Millan

  The DRM opt-in fallacy: "Your data belongs to us. We will decide when (and
  how) you may access your data; but nobody's threatening your freedom: we
  still allow you to remove your data and not access it at all."




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to maximilian attems <max@stro.at>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #24 received at 493925@bugs.debian.org (full text, mbox):

From: maximilian attems <max@stro.at>
To: Robert Millan <rmh@aybabtu.com>, 493925@bugs.debian.org
Subject: Re: Bug#493925: binary firmware in drivers/char/drm/mga_ucode.h
Date: Thu, 4 Sep 2008 15:02:43 +0200
On Thu, 04 Sep 2008, Robert Millan wrote:

> On Thu, Sep 04, 2008 at 02:14:28PM +0200, maximilian attems wrote:
> > severity 493925 wishlist
> > stop
> 
> I don't want to play BTS ping-pong, but this severity change is not right.
> Would you please revert it?

if it would.
 
> > as always stupid Debian wolf crying - disconnected from upstream work.
> > checkout 2.6.27-rcX they already ported several drivers to
> > request_firmware and if you *had* checked out linux-next you would
> > see that even more is in the pipe. 2.6.26 is not the right cut off.
> 
> Isn't .26 the version that will be used for lenny?

sure but as always these firmware guys only come creeping out of there
cages too late.
 
> > > Since the licensing terms allow redistribution, shipping it is not illegal but
> > > is a DFSG violation.
> > 
> > why?
> 
> DFSG #2.

no.


-- 
maks




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Holger Levsen <holger@layer-acht.org>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #29 received at 493925@bugs.debian.org (full text, mbox):

From: Holger Levsen <holger@layer-acht.org>
To: 493925@bugs.debian.org
Subject: Re: Bug#493925: binary firmware in drivers/char/drm/mga_ucode.h
Date: Fri, 5 Sep 2008 18:11:12 +0200
[Message part 1 (text/plain, inline)]
Hi,

On Thursday 04 September 2008 16:52, maximilian attems wrote:
> > So bug severity is based on timing now?
>
> great take things out of context.
>
> 2.6.26 is released and 2.6.27 merge window is over.
> for any one wanting to work on this issue the tree is open for 2.6.28,
> checkout linux-next for missing request_firmware() drivers.

So bug severity is based on timing now? *eg* or rather, *raises eyebrows and 
scratches head*.

vote 2006-007 only established an exception for etch, but not for the 
following releases. So why do you think this is not relevant for lenny? 
Are you planning a GR? ;)

Lenny will release with .26, not with .27 or .28.


regards,
	Holger, tempted to play bts ping pong^w^w^w^wraise the severity
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. Full text and rfc822 format available.

Message #32 received at 493925@bugs.debian.org (full text, mbox):

From: Robert Millan <rmh@aybabtu.com>
To: Holger Levsen <holger@layer-acht.org>, 493925@bugs.debian.org
Subject: Re: Bug#493925: binary firmware in drivers/char/drm/mga_ucode.h
Date: Fri, 5 Sep 2008 23:55:25 +0200
Hi,

On Fri, Sep 05, 2008 at 06:11:12PM +0200, Holger Levsen wrote:
> 
> vote 2006-007 only established an exception for etch, but not for the 
> following releases. So why do you think this is not relevant for lenny? 
> Are you planning a GR? ;)

It wouldn't be that bad.  It would probably pass, but this way at least we
aren't liing to our users about the freeness of Debian (not that I would
support that GR, anyway).

> 	Holger, tempted to play bts ping pong^w^w^w^wraise the severity

Btw, I brought this to the attention of the FTP team.  See #497823.

It's unfortunate that we couldn't had a reasonable discussion over this.  I
swear I tried.

-- 
Robert Millan

  The DRM opt-in fallacy: "Your data belongs to us. We will decide when (and
  how) you may access your data; but nobody's threatening your freedom: we
  still allow you to remove your data and not access it at all."




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. (Mon, 27 Oct 2008 17:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Thomas Viehmann <tv@beamnet.de>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Mon, 27 Oct 2008 17:42:05 GMT) Full text and rfc822 format available.

Message #37 received at 493925@bugs.debian.org (full text, mbox):

From: Thomas Viehmann <tv@beamnet.de>
To: 493925@bugs.debian.org, Ben Hutchings <ben@decadent.org.uk>
Subject: hmhm results with Ben's patch for mga drm firmware loading and G550
Date: Mon, 27 Oct 2008 18:39:29 +0100
Hi,

thanks, Ben, for looking into firmwares.
On my computer (using a G550), I'm seeing
[   62.796953] [drm] Initialized card for AGP DMA.
[   62.859094] firmware: requesting matrox/g400_warp.fw
[   63.032671] [drm:mga_warp_install_microcode] *ERROR* mga: Invalid
microcode "matrox/g400_warp.fw"
[   63.032671] [drm:mga_do_init_dma] *ERROR* failed to install WARP
ucode!: -22

instead of
[   67.385716] [drm] Initialized card for AGP DMA.

in dmesg when X starts with Ben's patch.
This may or may not be desirable: the mga X server fails to decently set
up the graphics modes either way (800x600/60 works, 1024x786/60 does but
flickers, for other resolutions, the display claims to receive Vertical
Refresh rates of <40Hz), so maybe the old thing just failed silently,
but all of this seems unchanged by the patch.

Kind regards

T.
-- 
Thomas Viehmann, http://thomas.viehmann.net/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#493925; Package linux-2.6. (Wed, 29 Oct 2008 03:42:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Wed, 29 Oct 2008 03:42:02 GMT) Full text and rfc822 format available.

Message #42 received at 493925@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Thomas Viehmann <tv@beamnet.de>, 493925@bugs.debian.org
Subject: Re: Bug#493925: hmhm results with Ben's patch for mga drm firmware loading and G550
Date: Wed, 29 Oct 2008 03:44:28 +0000
[Message part 1 (text/plain, inline)]
On Mon, 2008-10-27 at 18:39 +0100, Thomas Viehmann wrote:
> Hi,
> 
> thanks, Ben, for looking into firmwares.
> On my computer (using a G550), I'm seeing
> [   62.796953] [drm] Initialized card for AGP DMA.
> [   62.859094] firmware: requesting matrox/g400_warp.fw
> [   63.032671] [drm:mga_warp_install_microcode] *ERROR* mga: Invalid
> microcode "matrox/g400_warp.fw"
> [   63.032671] [drm:mga_do_init_dma] *ERROR* failed to install WARP
> ucode!: -22

This is a sanity-check on the file format, and it fails which means
either the check or the firmware file is broken.

It turns out the firmware file was broken because the ihex2fw tool I
used to generate it is not consistent with the ihex.h header used to
parse it.  This is weird because they came from the same place!  I've
fixed up the ihex2fw tool and regenerated the Matrox firmware files.  I
created a user-mode test program based on the code in ihex.h and the
code I introduced to mga_ucode.c and this accepts the new file.

I uploaded a new version of firmware-nonfree (0.13.3) to
<http://people.debian.org/~benh/firmware-removal/>; please test the new
firmware-matrox package.

> instead of
> [   67.385716] [drm] Initialized card for AGP DMA.
> 
> in dmesg when X starts with Ben's patch.
> This may or may not be desirable: the mga X server fails to decently set
> up the graphics modes either way (800x600/60 works, 1024x786/60 does but
> flickers, for other resolutions, the display claims to receive Vertical
> Refresh rates of <40Hz), so maybe the old thing just failed silently,
> but all of this seems unchanged by the patch.

So far as I know, 2D functionality should be unchanged by this patch,
whether or not the firmware is installed.

Ben.

[signature.asc (application/pgp-signature, inline)]

Bug marked as fixed in version 2.6.29-1, send any further explanations to Robert Millan <rmh@aybabtu.com> Request was from Ben Hutchings <ben@decadent.org.uk> to control@bugs.debian.org. (Mon, 08 Jun 2009 02:33:03 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 15 Aug 2009 07:33:27 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 07:58:57 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.